define('lts-activity:widget/hybridApi/hybridApi.js', function(require, exports, module){ /* Copyright (c) 2015 Baidu, All rights reseved.
 * @fileoverview 前端与移动端通信接口
 * @author qinmudi | qinmudi@baidu.com
 * @version 1.0 | 2015-05-25 | qinmudi      // 初始版本。
 * @version 1.1 | 2016-01-25 | wangyan01    // 从practice模块同步过来
 */
    var guid = require('common:widget/util/guid.js');

    function HybridApi() {
        var protocol = "iknowhybrid://";
        var callbackCount = 0;
        var id = guid(32);

        function createBridge(src) {
            var bridge = document.createElement("iframe");
            bridge.setAttribute("style", "display:none;");
            bridge.setAttribute("height", "0px");
            bridge.setAttribute("width", "0px");
            bridge.setAttribute("frameborder", "0");
            document.documentElement.appendChild(bridge);
            return bridge;
        }
        //action必填，其他的选填
        function buildUrl(action, params, callback) {
            var url = protocol + action + "?";
            url += "data=" + encodeURIComponent(JSON.stringify(params || {}));
            if (callback) {
                var callbackName = "__cb__" + id + '__' + callbackCount++;
                window[callbackName] = function() {
                    callback && callback.apply(window, arguments);
                }
                url += "&__callback__=" + callbackName;
            }
            return url;
        }
        this.exec = function(action, params, callback) {
            var bridge = createBridge();
            bridge.setAttribute('src', buildUrl(action, params, callback));
            setTimeout(function() {
                bridge.parentNode.removeChild(bridge);
                bridge = null;
            }, 0);
        }
    }

    module.exports = HybridApi;
});