/**
 * Copyright (c) 2014-2016 Baidu, All rights reseved.
 * @fileoverview 关于作业帮
 * @author RongZhiqiang | RongZhiqiang@zuoyebang.com
 * @version 1.0 | 2016-09-06 | RongZhiqiang          //初始版本
 **/
"use strict";

var $ = require('common:widget/lib/zepto/zepto.js'),
    BulletScreen=require('lts-activity:widget/blackboard/m-bulletScreen.js'),
    HybridApi = require('lts-activity:widget/hybridApi/hybridApi.js');

var hybridApi = new HybridApi();
$(function () {
    var count = 0,cuid= 0,timer1,timer2;
    var imgList = [
        './images/bell1.png',
        "./images/bell2.png"
    ];

    function getVcName() {
        hybridApi.exec('common',{},function(res){
            cuid=res.cuid;
            var vcname = res.vcname||"7.0.2";
            $("#vcname").html(vcname);
        });
    };
    getVcName();

    //非安卓不显示同步版本号
    if (!/android/i.test(navigator.userAgent)) {
        $("#refreshBtn").hide();
    }

    var index = 0;
    var timer = function(index){
        timer1 = setTimeout(function(){
            $("#bellImg").attr('src',imgList[index]);
            index++;
            index = index == 2?0:index;
            timer(index);
        },150);
    };

    //点击打铃
    $(".bellImgBox").on('click',function(){
        if (!$(this).hasClass("isBelling")) {
            $(this).addClass("isBelling");
            count++;
        }
        amazing();
        timer(index);
    });

    //彩蛋按钮点击
    $("#surprise").on('click','.btns',function(){
        var _this = $(this),
            _index = _this.index();
        if (!_this.hasClass("isChecked")) {
            _this.addClass('isChecked');
            count++;
            amazing();
        }
        switch (_index){
            case 0:
            case 3:
            case 4:
            case 7:
                _this.addClass('duration leftRotate');
                break;
            case 1:
            case 2:
            case 6:
            case 5:
                _this.addClass('duration rightRotate');
                break;
            default:
        }
    });

    //使用协议
    $(".protocol").on('click',function(){
        hybridApi.exec('openWindow',{url:'http://www.zybang.com/zuoyebang/xieyi/index.html'});
    });

    //跳转品牌页面
    $(".brand").on('click',function(){
        hybridApi.exec('openWindow',{url:'http://www.zybang.com/zuoyebang/shengrikuaile.html'});
    });

    //彩蛋浮层
    function amazing(){
        if (count>8) {
            setTimeout(function(){
                $("#barrage").html("");
                $("#barrage").add($("#closeBtn")).show();
                var bulletScreen= new BulletScreen({
                    host:'#barrage',
                    color:'#f3f3f3'
                });

                var style={
                    color:'#f9f9f9',
                    padding:'5px 15px',
                    borderRadius:'15px',
                    background:'rgba(220,220,220,.1)'
                };

                var bullets=[
                    '~~About us~~biubiubiu',
                    '重阳：更快、更强、更好用',
                    "纪平：小朋友，要好好学习呦，么么哒",
                    "玉良：祝作业帮越来越好！",
                    "波超：祝福作业帮越来越好",
                    '林峰：作业帮能够伴你一路前行，快乐学习',
                    "男神：愿你，我，它相知相伴，共同成长~",
                    "小姜：Better be better",
                    "t10：右边的人没我帅→_→",
                    '凯bro：good good  study，day day up',
                    "聪姐：我和作业帮一起成长，加油！",
                    "王岩：长风破浪会有时，直挂云帆作业帮",
                    "志强：提供优质的学习体验是我们的使命！",
                    "春春：要经常用作业帮，好好学习哦",
                    "济豪：biubiubiubiubiu",
                    "学磊：乘风破浪前程广，鼎立创新步步高",
                    "志阳：作业帮是最好的",
                    "海霞：作业帮帮助更多孩子们提高成绩",
                    "贤铭：邻家小孩用作业帮，成绩up up！",
                    "宝山：愿作业帮能帮助到越来越多的同学！",
                    "曹越：我最帅",
                    "小南：玩爽学好吃饱睡早23333",
                    "睿涛：风雨清北路，作业帮与你同行",
                    "燕燕：木有文采哎",
                    "佳男：双击666！！！",
                    "天鹏：不知道写什么…",
                    "华少：平台组谁最帅？Me！！",
                    "小yiyi：哇，代码好cool",
                    "艳红：作业帮，bangbang棒！",
                    "冯玉：平台组谁最美？Me！！",
                    "阳阳：祝万千学子学业有成～",
                    "陈征：容我思考一会儿",
                    "唐总：说点什么好呢~咩"
                ];

                var bsIndex = 0;
                var interval = function(cycle) {
                    timer2 = setTimeout(function(){
                        var _x = Math.floor(Math.random()*2.2)+1;
                        var _len = (bullets.length - bsIndex>_x)?(bsIndex+_x):bullets.length;
                        var newArr = bullets.slice(bsIndex,_len);
                        for (var i = 0;i<newArr.length;i++) {
                            bulletScreen.shoot(newArr[i],style);
                            bsIndex++;
                            bsIndex = bsIndex == bullets.length?0:bsIndex;
                        }
                        interval(Math.floor(1000+Math.random()*200))
                    },cycle);
                };
                interval(Math.floor(1000+Math.random()*200));
            },1000);

            hybridApi.exec('is_login',{},function(res){
                if(res.isLogin) {
                    $.post('http://www.zybang.com/napi/skin/eggmedal',{},function(res){});
                }
            });
        }
    }

    //关闭弹幕浮层
    $("#closeBtn").on('click',function(){
        $("#barrage").html("");
        $("#barrage").add($(this)).hide();
        $("#surprise").find('li').each(function(){
            var _this = $(this);
            _this.removeClass('duration isChecked leftRotate rightRotate');
        });
        $(".bellImgBox").removeClass('isBelling');
        clearTimeout(timer1);
        clearTimeout(timer2);
        $("#bellImg").attr('src',imgList[0]);
        count=0;
    });

    //同步版本号
    $("#refreshBtn").on('click',function(){
        $(this).addClass('rotate1');
        hybridApi.exec('updateCheck',{},function(){
            $("#refreshBtn").removeClass('rotate1');
        });
    });

    //阻止document touch事件
    $("#barrage").on('touchmove',function(e){
        window.event? window.event.returnValue = false : e.preventDefault();
    })

    //pv,uv打点
    new Image().src='http://www.zybang.com/napi/stat/addnoticev1?page=app_about_zyb&type=showpv';
    new Image().src='http://www.zybang.com/napi/stat/addnoticev1?page=app_about_zyb&type=showuv&cuid=' + cuid;
});