define('lts-activity:widget/blackboard/m-bulletScreen.js', function(require, exports, module){ function BulletScreen(config){
    if(!config){
        throw new Error('[BulletScreen Exception]: No arguments.');
    }
    else if(!$(config.host).length){
        throw new Error('[BulletScreen Execption]: Invalid arguments host is needed');
    }
    else{
        this.host=$(config.host);
        this.fontSize=config.fontSize;
        this.screen=$('<div class="wgt_bullet_screen"></div>').appendTo(this.host);
        $(config.host).on('transitionend webkitTransitionEnd','.wgt_bullet',function(){
            $(this).remove();
        });//动画结束就销毁
    }
}
    BulletScreen.prototype._randomStyle=function(){
        var baseFontSize=this.host.css('font-size'),
            fontSize=this.fontSize?this.fontSize:(1+Math.random()*0.5)*baseFontSize,
            width=document.body.clientWidth;
        return {
            fontSize:fontSize+'px',
            left:width+'px',
            '-webkit-transition':'-webkit-transform 5s linear',
            transition:'transform 5s linear'
        }
    }
    BulletScreen.prototype._index=0;
    BulletScreen.prototype.show=function(){
        this.screen.show();
    }
    BulletScreen.prototype.hide=function(){
        this.screen.hide();
    }

    BulletScreen.prototype.shoot=function(text,style){
        var randomStyle=this._randomStyle();
        var bullet=$('<div class="wgt_bullet"></div>')
            .css($.extend(randomStyle,style))
            .html(text)
            .appendTo(this.screen);
        this.show();
        var height=bullet.height(),
            index=this._index++%(parseInt(this.host.height()/(height+10))),
            top=index*(height+10)+8;
        top>this.host.height()-height-10?this.host.height()-height-10:top;
        bullet.css('top',top);
        if(bullet.text()){
            var width=bullet.width()+parseInt(randomStyle.left)+'px';
            bullet.css({
                '-webkit-transform':'translateX(-'+width+')',
                transform:'translateX(-'+width+')'
            });
        }
    };

    module.exports=BulletScreen;

});